package automat;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;
import java.util.Stack;

/**
 * 
 * @author Antonin Neumann
 *
 */
public class Automat {
	
	/*Tyto promnn lze nastavit argumenty*/
	/** Poet minc kad nominln hodnoty pi startu automatu<br> Nastavuje se prvnm argumentem */
	private static int POCET_MINCI = 500;
	/** Poet lstk kter me automat vydat<br> Nastavuje se druhm argumentem */
	private static int POCET_LISTKU = 100;
	/** Debug reim - vypisuje kontroln vpisy<br> Nastavuje se tetm argumentem */
	private static boolean DEBUG = false;
	
	/*Mincovn zsobnky*/
	private static Stack<Integer> vhozeneMince = new Stack<Integer>();
	private static Stack<Integer> pokladnicka = new Stack<Integer>();
	
	private static ArrayList<Karta> karty = new ArrayList<Karta>();
	
	private static Scanner vstup = new Scanner(System.in);
	
	private static Listek[] listky = {
		null,
		new Listek(18, 'A', false, 30),
		new Listek(9, 'A', true, 30),
		new Listek(24, 'A', false, 60),
		new Listek(12, 'A', true, 60),
		new Listek(80, 'A', false, 1440),
		new Listek(40, 'A', true, 1440),
		new Listek(24, 'B', false, 30),
		new Listek(12, 'B', true, 30),
		new Listek(36, 'B', false, 60),
		new Listek(18, 'B', true, 60),
		new Listek(120, 'B', false, 1440),
		new Listek(60, 'B', true, 1440)
	};
	
	/** Vstupni metoda programu
	 * 
	 * @param args Definice pocatecnich promennych automatu
	 */
	public static void main(String[] args) {
		if(args.length >= 1 && !args[0].isEmpty()) {
			try {
				POCET_LISTKU = Integer.parseInt(args[0]);
			}catch (NumberFormatException e){
				System.out.println(e);
			}
		}
		
		if(args.length >= 2 && !args[1].isEmpty()) {
			try {
				POCET_MINCI = Integer.parseInt(args[1]);
			}catch (NumberFormatException e){
				System.out.println(e);
			}
		}
		
		if(args.length >= 3 && (args[2].equalsIgnoreCase("debug") || args[2].equalsIgnoreCase("true"))) {
			DEBUG = true;
		}

		setCards();
		
		start();
	}
	
	public static void start(){
		int volba = 0;
		while(true){
			if(POCET_LISTKU <= 0){
				exit(1, "Dosli listky");
			}
			
			for (int i = 1; i < listky.length; i++) {
				System.out.println(i+ " \t" +listky[i].getNazev());
			}
			System.out.println("22 \tZustatek karty");
			System.out.println("Q \tSTORNO");
			
			dump("Pocet listku: " + POCET_LISTKU + ", pocet minci: " + POCET_MINCI + ", DEBUG: " + DEBUG);
			
			try {
				System.out.println("Zvolte moznost");
				String s = vstup.nextLine();
				if(jeStorno(s))
					start();
				else
					volba = Integer.parseInt(s);
			}catch(NumberFormatException e){
				System.out.println("Neplatna volba: " + e);
			}
			
			switch (volba) {
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
			case 11:
			case 12:
				dump("Zvolili jste: "+volba);
				vydejListek(volba);
				break;
				
			case 22:
				dump("Zvolili jste: "+volba);
				zustatekKarty();
				break;

			case 0:
				//dolo k vyjmce a promnn "volba" zstala na hodnot 0
				break;
			default:
				System.out.println("Neplatna volba - default");
				volba = 0;
				break;
			}
		}
		
	}
	
	public static void vydejListek(int typ){
		int x = 0;
		boolean jeKarta;
		
		while(true){
			System.out.println("Chcete zaplatit zakaznickou kartou?\n1: Ano \t0: Ne");
			try {
				String s = vstup.nextLine();
				
				if(jeStorno(s)){
					System.out.println("Zmackuto STORNO");
					start();
				} else {
					x = Integer.parseInt(s);
				}
				
				if(x == 1) {
					jeKarta = true;
					break;
				}
				else if(x == 0) {
					jeKarta = false; 
					break;
				}
				else {
					System.out.println("Neplatna volba");
				}
			} catch (NumberFormatException e) {
				dump(e.toString());
				System.out.println("Neplatna volba");
			}
		}
		dump("Karta: " + jeKarta);
		
		Listek listek = listky[typ];
		dump("Zvolili jste: "+listek.toString());
		
		if(jeKarta){
			if(platbaKartou(listek.getCena())){
				tiskListku(listek);
			}else {
				System.out.println("Platba bude realizovana hotove");
				platbaHotove(listek.getCena());
				tiskListku(listek);
			}
		}else {
			platbaHotove(listek.getCena());
			tiskListku(listek);
		}
	}
	
	/**
	 * Nate ID karty a ov jestli existuje.
	 * @return <strong>Karta</strong> k pokud karta existuje nebo <strong>NULL</strong>
	 */
	public static Karta overKartu(){
		System.out.println("Zadejte cislo karty");
		int id = 0;
		try {
			String s = vstup.nextLine();
			if(jeStorno(s)){
				System.out.println("Znacknuto STORNO");
				dump("STORNO in overKartu()");
				start();
			} else {
				id = Integer.parseInt(s);
			}
			
		} catch (NumberFormatException e) {
			System.out.println("Cislo karty musi byt cislo");
		}

		for (int i=0; i < karty.size(); i++) {
	    	Karta karta = karty.get(i);
	        if (karta.getId() == id){
	        	dump("Karta s ID " +id+ " existuje - " +karta.getJmeno());
	        	return karta;
	        }
	    }
	    return null;
	}
	
	/**
	 * Pokud karta existuje vypise jeji zustatek
	 */
	public static void zustatekKarty(){
		Karta k = overKartu();
		if(k != null)
			zustatekKarty(k);
		else 
			System.out.println("Karta neexistuje");
	}
	
	public static void zustatekKarty(Karta k){
		System.out.println("Zustatek na karte " +k.getId()+ "("+k.getJmeno()+") je " +k.getKredit()+ " korun");
	}
	
	public static int prijmiPenize(int castka){
		int suma = 0;
		int mince = 0;
		while(suma < castka){
			System.out.println("Jeste zbyva zaplatit " +(castka-suma)+ "Kc");
			System.out.println("Vhodte minci (1, 2, 5, 10, 20)");
			try {
				String s = vstup.nextLine();
				if(jeStorno(s)){
					System.out.println("Znacknuto STORNO");
					dump("STORNO in prijmiPenize(...)");
					if(!vhozeneMince.empty()){
						System.out.println("Vracim vhozene mince" +vhozeneMince.toString());
					}
					vhozeneMince.clear();
					start();
				} else {
					mince = Integer.parseInt(s);
					if(mince == 1 || mince == 2 || mince == 5 || mince == 10 || mince == 20){
						vhozeneMince.add(mince);
						suma += mince;
					}
				}
			} catch (NumberFormatException e) {
				dump(e.toString());
			}
		}
		return suma; //pijat stka
	}
	
	public static void vratPenize(int castka){
		if(POCET_MINCI >= castka){
			System.out.println("Vracim "+castka+"Kc");
			POCET_MINCI -= castka;
		}else {
			System.out.println("Automat nema na vraceni");
			System.out.println("Vracim vhozene mince" +Arrays.toString(vhozeneMince.toArray()));
			vhozeneMince.clear();
			exit(2, "Automat nema na vraceni");
		}
	}
	
	public static void platbaHotove(int castka){
		int suma = prijmiPenize(castka);
		vratPenize(suma-castka);
		ulozPenize();
	}
	
	public static boolean platbaKartou(int castka){
		while(true){
			Karta k = overKartu();
			if(k != null){
				if(k.getKredit() >= castka){
					k.odectiKredit(castka);
					zustatekKarty(k);
					return true;
				}else {
					System.out.println("Na karte neni dostatecny obnos k zaplaceni");
					return false;
				}
			}else {
				System.out.println("Tato karta neexistuje");
			}
		}		
	}
	
	/**
	 * Ulozi penize ze zasobniku vhozenych minci do pokladnicky
	 */
	public static void ulozPenize(){
		dump("Ukladam penize...");
		pokladnicka.addAll(vhozeneMince);
		vhozeneMince.clear();
	}
	
	public static void tiskListku(Listek listek){
		System.out.println("Tisku listek: "+listek.getText());
		POCET_LISTKU--;
	}
	
	
	public static void exit(int x, String s){
		System.out.println("Automat je mimo provoz");
		System.err.println(s + " (" + x + ")");
		System.exit(x);
	}
	
	/**
	 * Nastavi pocatecni zakaznicke karty
	 */
	public static void setCards(){
		karty.add(new Karta(1001, "Antonin", "Neumann", 2000));
		karty.add(new Karta(1002, "Jan", "Novak", 100));
		karty.add(new Karta(1003, "David", "Kosek", 500));
		karty.add(new Karta(1004, "Petr", "Huml", 50));
		karty.add(new Karta(1005, "Jakub", "Zika", 12));
	}
	
	/**
	 * Zjisti jestli bylo znacknuto STORNO<br>
	 * STORNO je reprezentovno znakem Q
	 * 
	 * @param s String
	 * @return TRUE pokud bylo "vyvolano" <storng>storno</strong>. jinak FALSE
	 */
	public static boolean jeStorno(String s){
		if(s.equalsIgnoreCase("Q") || s.equalsIgnoreCase("STORNO"))
			return true;
		else
			return false;
	}
	
	/**
	 * Vype etzec pokud je promnn DEBUG nastavena na TRUE
	 * 
	 * @param s String
	 */
	public static void dump(String s){
		if(DEBUG) System.out.println("DEBUG "+s);
	}

}

class Listek {
	
	private int cena;
	private String nazev;
	private String text;
	private char zona;
	private boolean zlevnena;
	private int platnost;
	
	public Listek(int cena, char zona, boolean zlevnena, int platnost){
		this(cena, zona, zlevnena, platnost, "");
		if(zlevnena)
			this.nazev = "Zlevnena ZONA "+zona+" "+platnost+ "MIN";
		else
			this.nazev = "Plnocena ZONA "+zona+" "+platnost+ "MIN";
	}
	
	public Listek(int cena, char zona, boolean zlevnena, int platnost, String nazev){
		this.cena = cena;
		this.zona = zona;
		this.zlevnena = zlevnena;
		this.platnost = platnost;
		this.nazev = nazev;
		if(zlevnena)
			this.text = "Zlevnen jizdenka. Platna "+platnost+" minut v zone "+zona+". Cena "+cena+"Kc.";
		else 
			this.text = "Plnocenna jizdenka. Platna "+platnost+" minut v zone "+zona+". Cena "+cena+"Kc.";
	}

	public int getCena() {
		return this.cena;
	}
	
	public char getZona() {
		return this.zona;
	}

	public String getNazev() {
		return this.nazev;
	}

	public String getText() {
		return this.text;
	}

	@Override
	public String toString() {
		return ""+this.nazev+": [ zona "+this.zona+", cena "+this.cena+", platnost "+this.platnost+", zlevnena "+this.zlevnena+", "+this.text+" ]";
	}
	
	
}

/**
 * Trida reprezentujici zakaznickou kartu
 * 
 * @author Antonin Neumann
 *
 */
class Karta {
	
	private int id;
	private String krestni;
	private String prijmeni;
	private int kredit;
	
	public Karta(int id){
		this(id, null, null);
	}
	
	public Karta(int id, String krestni, String prijmeni){
		this(id, krestni, prijmeni, 0);
	}
	
	public Karta(int id, String krestni, String prijmeni, int kredit){
		this.id = id;
		this.krestni = krestni;
		this.prijmeni = prijmeni;
		this.kredit = kredit;
	}
	
	public int getId(){
		return this.id;
	}
	
	public String getKrestni(){
		return this.krestni;
	}
	
	public String getPrijmeni(){
		return this.prijmeni;
	}
	
	public String getJmeno(){
		return this.krestni+" "+this.prijmeni;
	}
	
	public int getKredit(){
		return this.kredit;
	}
	
	public void setKredit(int castka){
		this.kredit += castka;
	}
	
	public void odectiKredit(int castka){
		this.kredit -= castka;
	}
	
	@Override
	public String toString(){
		return this.id+ "[" +this.getJmeno()+ ", " +getKredit()+ "]";
	}
	
}
